<?php

/*
 *  hash_blockparser.php3 - 
 *
 *  Copyright (C) 2001 STRASSER Michel
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


 
  ///////////////////////////////
  //
  //  this is the hash blockparser
  //
  //  for a line with n rows, it creates n - 1 dictionnaries where the keys
  //  are the element of the first row and the values are the elements of the j-th row 
  //  ( 1 <= j <= n )
  //
  class hash_blockparser extends blockparser{
    var $errors="";
    var $is_dicts_setted;
    var $array; // the returned array ( at conclusion)
    var $dicts; // the names of the rows
    var $name; // name of block, a string
    var $hello;
    var $was_errors=false;

    function hash_blockparser ($name) {
      $this->name=$name;
      $this->is_dicts_setted=false;
    }

    function parse_line($my_line, $line_number) {
      global $separator_character;
      $my_line_array = explode( $separator_character, $my_line);

      $i=1;

      if ($this->is_dicts_setted) {
        if (count($this->dicts)>=(count($my_line_array) - 1)) {
          while ($i < count($my_line_array)) {
            $this->array[$my_line_array[0]][$this->dicts[$i - 1]]=$my_line_array[$i];
            $i++;
          }
	}
	else {
          $this->errors.="\nParse error, at line $line_number, 
	    the block should not contain anything after the " . 
	    $this->dicts[count($this->dicts)-1] . 
	    " row : " . substr($my_line, 0, 60) . "...";
	  $this->was_errors=true;
	}
      }
      else {
        while ($i < count($my_line_array)) {
          $this->array[$my_line_array[0]][$i - 1]=$my_line_array[$i];
          $i++;
        }
      }
    }

    function conclusion () {
      global $data_tree;
      if ($this->was_errors){
        return(false);

      }
      else {
        $data_tree[$this->name]=$this->array;
        return(true);


      }
    }

    function get_errors() {
      return($this->errors);
    }

    function set_dicts($dicts) {
      //  the dicts argument is a string in which we put the name of 
      //  the outputted dictionnary we want separated with ";"
      $this->dicts = explode(";" , $dicts);
      $this->is_dicts_setted=true;
    }
  }

?>
