<?php

/*
 *  parser.php3 - parse the config file 
 *
 *  Copyright (C) 2001 STRASSER Michel
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


   include ("blockparsers/list.php3");
  
  class parser {
    var $config_filename;
  
    function parser () {

    }
    
    function parse () {
      global $max_line_size, $separator_character, $items, $my_theme, $my_blockparsers;
      $is_in_block=false;
      $current_block="";
      $was_errors=false;

      // translations
      
      $tra_parsing="Parsing ...";
      $tra_parsing_block="Parsing block ";

      
      $my_file=fopen($this->config_filename, "r");
      // I don't need the first line
      fgets($my_file,  $max_line_size);
      $i=1;
      while (!feof($my_file)) {
        $my_line=fgets($my_file, $max_line_size);

	if (ereg("([a-z]+)|([A-Z]+)|([0-9]+)|\t[(\t*)( *)]#",$my_line)) {
	  $my_line_array = explode( $separator_character, $my_line);
	  if ($my_line_array[0]=="BEGIN") {
	    if ($is_in_block) {
	        $items.=$my_theme->check_list_item ($tra_parsing, false, "Parse error, 
	        at line $i, BEGIN statement occured in a already block sentence : 
		  " . substr($my_line, 0, 60) . "...");
	      }
	      else {
	        $is_in_block=true;
	        if (ereg("([A-Z]+)", $my_line_array[1])) {
		  $current_block=trim($my_line_array[1]);
		}
		else {
		  $items.=$my_theme->check_list_item ($tra_parsing, false, "Parse error, 
  	            at line $i, attempting to get block name but got ($my_line_array[1]) : 
		    " . substr($my_line, 0, 60) . "...");
		  $was_errors=true;
		}
	      }

	  } 
	  else {
	    if (ereg("^END", $my_line)) {
	      if (!$is_in_block) {
	        $items.=$my_theme->check_list_item ($tra_parsing, false, "Parse error, 
	        at line $i, END statement in a non block sentence : 
		  " . substr($my_line, 0, 60) . "...");
		  $was_errors=true;
	      }
	      else {
	        $is_in_block=false;
		if ($my_blockparsers[$current_block]) {
		  if ($my_blockparsers[$current_block]->conclusion()) {
  		    $items.=$my_theme->check_list_item ($tra_parsing_block . $current_block, 
  		    true, "");
		  }
		  else {
		    $items.=$my_theme->check_list_item ($tra_parsing_block . $current_block, false, $my_blockparsers[$current_block]->get_errors());
		    $was_errors=true;
		  }
		}
		else {
		  $items.=$my_theme->check_list_item ($tra_parsing_block . $current_block, 
		    false, "Parse error, 
	            at line $i, call to undefined block parser object $current_block <br>
		    Developper, have you forgotten to implement your new block parser object ?
		    Please take a look at blockparsers/list.php3 ! : <br>
		    " . substr($my_line, 0, 60) . "...");
		    $was_errors=true;
		}
		$current_block="";
	      }
	    } 
	    else { 
	      if  ($my_line_array[0]!="") {
	        // the first row is not empty : ERROR
	        $items.=$my_theme->check_list_item ($tra_parsing, false, "Parse error, 
	        at line $i, first col is nor BEGIN, nor END and nor (empty) : 
		  " . substr($my_line, 0, 60) . "...");
		$was_errors=true;
	      }
	      else { 
	        if (ereg("^\t((\t*)|( *))#",$my_line)) {
                  //the line is a comment : ignored
	        }
	        else {
	          // given to a blockparser
		  //building sentence :
		  $j=1;
		  $line_given_to_block_parser="";
		  while ($j<count($my_line_array)) {
		    $line_given_to_block_parser.=$my_line_array[$j] . $separator_character;
		    $j++;
		  }
		  if (isset($my_blockparsers[$current_block])) {
  	            $my_blockparsers[$current_block]->parse_line(trim($line_given_to_block_parser), $i);
		  }
		  else {
                    // the current block parser does not exist yet
		    // we will send a message once the END statement occured ...
		  }
	        }
	      }	
	    }	
	  }
	}
	else {
            //the line is empty : ignored
	}
	$i++;
      }
      fclose($my_file);
      return(!$was_errors);

    }

    function set_config_filename ($filename) {
      $this->config_filename=$filename;
    }
  }

?>
